	//float secs_elapsed = clock()/(float)CLOCKS_PER_SEC;
	//printf("%.4f",sec_elapsed);
	//(double)clock();


//#include <stdlib.h>
#include <iostream>
#include <math.h>
#include <GL/glut.h>
using namespace std;

bool starfield=true;

float changeGameSpeed = 120.0;
float gamespeed;
double v=1;

GLuint texName[15];
int textureNum=0;


int myframe=0,mytime,timebase=-1;
float fps=100.0;
	
static float camx=0.0f,camy=0.0f,camz=0.0f;
static float angle=0.0;
static float ax=0.0f,ay=0.0f,az=-1.0f;
static float deg = 3.141592653/180.0;



//static float

static float shipx=0;
static float shipy=-.5;

static float discx=0,discxo=0;
float discy=0,discyo=0;
float discangle=0;

float enemyx=0,enemyxo=0;
float enemyy=0.5,enemyo=0;
float enemyangle=0;
//float enemyangleo=0;



// Level:
//float enemyspeed=2.6;
//float enemyspeed=5.45;
float enemyspeed=1; // Level 1

float enemySpeedupRate=0.0002;


float shipxthrust=0;
float shipythrust=0;
float thrust=25000; // lower = faster
float booster=200;
float power=1.0;

int hit=0; // Pocket pots
int frame=0; // frame number

float shipDiscDistance=0;

float shipAngleFromDisc=0;

float shipangle=0;

float platformRotation;
float platformRotationSpeed=0.01;
float prs=0;

int pocketTopHitCount=0;
int pocketLeftHitCount=0;
int pocketRightHitCount=0;

float planetx=-2.5;
float planety=-2.85;
float planetx2=0.5;
float planety2=2;
float planetx3=-4;
float planety3=1.5;

float rotd=0;
float roto=0;

//float shipthrust=0;

bool kdown=false;
bool shipAim=false;
bool pottable;
bool takingShot;
bool gameover;
bool warning;
bool intro=true;

int gameOverCountDown=500;
bool gameoverStart=false;

int inPocket=0;

int shipAimRotDirection=1;

bool KeyDown[256];

int timeSinceLastReboundA;
int timeSinceLastReboundB;
int timeSinceLastReboundC;
int timeSinceLastReboundD;



void orientMe();
void resetVars();
float getAngle(float x1,float y1,float x2,float y2);
float getDistance(float x1,float y1,float x2,float y2);
float myfabs(float n);
void detect();
void detect2();
void renderBitmapString(float x, float y, void *font, char *string);
//GLubyte checkImage[imageHeight][checkImageWidth][4];


//void loadImage();




void display()
{
	 	
 	 
	 frame++;
	 glClear(GL_COLOR_BUFFER_BIT);
	
	
	
	// Enable texturing:
	glEnable(GL_TEXTURE_2D);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

	myframe++;
	mytime=glutGet(GLUT_ELAPSED_TIME);


	if (mytime - timebase > 100) {
		if (timebase>-1)	fps = myframe*1000.0/(mytime-timebase);
		//cout << fps << endl;
		 timebase = mytime;
		myframe = 0;
	}


 	 if (intro==true) {
		//glPushMatrix();
			glBindTexture(GL_TEXTURE_2D, texName[13]);
				glBegin(GL_POLYGON);
				glTexCoord2f(0  ,1-  0);     glVertex2f(-1,-1);
				glTexCoord2f(0  ,1-  1);   glVertex2f(-1, 1);
				glTexCoord2f(1  ,1-  1);   glVertex2f(1 , 1);
				glTexCoord2f(1  ,1-  0);     glVertex2f(1 ,-1);
			glEnd();
			
			
		glDisable(GL_BLEND);
		glDisable(GL_TEXTURE_2D);
 		
		if(frame%((int)(80000.0/changeGameSpeed)) < (int)(40000.0/(changeGameSpeed))) {
			glColor3f(1.0,0.5,0.0);
			char tstart[50];
			sprintf(tstart," PUSH SPACE TO START!");
			renderBitmapString(-0.27+camx, 0.26+camy, GLUT_BITMAP_HELVETICA_18, tstart);
		}
			
			
				
		//glPopMatrix();
	//	Sleep(1000);
     }	 	

  else {
  	   
  	   
  	   
	/////////////// Draw starfield:
	//////////////////////////////
	//for (int uy=0 ; uy<355 ; uy++) {
	if (starfield==true) {
		int starsize=5;
		glBindTexture(GL_TEXTURE_2D, texName[10]);
		glBegin(GL_POLYGON);
			glTexCoord2f(0  ,1-  0);     glVertex2f(-1*starsize+shipy,-1*starsize+shipx/2);
			glTexCoord2f(0  ,1-  1*starsize);   glVertex2f(-1*starsize+shipy, 1*starsize+shipx/2);
			glTexCoord2f(1*starsize  ,1-  1*starsize);   glVertex2f(1*starsize+shipx , 1*starsize+shipy/2);
			glTexCoord2f(1*starsize  ,1-  0);     glVertex2f(1*starsize+shipx ,-1*starsize+shipy/2);
		glEnd();
	}
	//}



   // Enable translucency for any future graphics
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);






	////////////////// Draw Background spaceships at intervals:
	/////////////////////////////////////////////
	//
	// Spaceship 1:
	if (enemyspeed>2.6 && enemyspeed<3.6) {
		glPushMatrix();
			glTranslatef(planetx, planety, 0.0);
			glRotatef(frame/8.0, 0.0, 0.0, 1);
			glBindTexture(GL_TEXTURE_2D, texName[11]);
				glBegin(GL_POLYGON);
				glTexCoord2f(0  ,1-  0);     glVertex2f(-1/4.0,-1/4.0);
				glTexCoord2f(0  ,1-  1);   glVertex2f(-1/4.0, 1/4.0);
				glTexCoord2f(1  ,1-  1);   glVertex2f(1/4.0 , 1/4.0);
				glTexCoord2f(1  ,1-  0);     glVertex2f(1/4.0 ,-1/4.0);
			glEnd();	
		glPopMatrix();
	}
	//
	// Spaceship 2:
	if (enemyspeed>5.4 && enemyspeed<6.5) {
		glPushMatrix();
			glTranslatef(planetx2, planety2, 0.0);
			glRotatef(frame/8.0, 0.0, 0.0, 1);
			glBindTexture(GL_TEXTURE_2D, texName[12]);
				glBegin(GL_POLYGON);
				glTexCoord2f(0  ,1-  0);     glVertex2f(-1/2.0,-1/2.0);
				glTexCoord2f(0  ,1-  1);   glVertex2f(-1/2.0, 1/2.0);
				glTexCoord2f(1  ,1-  1);   glVertex2f(1/2.0 , 1/2.0);
				glTexCoord2f(1  ,1-  0);     glVertex2f(1/2.0 ,-1/2.0);
			glEnd();	
		glPopMatrix();
	}
	//
	// Spaceship 3:
	if (enemyspeed>8 && enemyspeed<9.2) {
		glPushMatrix();
			glTranslatef(planetx3, planety3, 0.0);
			glRotatef(frame/8.0, 0.0, 0.0, 1);
			glBindTexture(GL_TEXTURE_2D, texName[12]);
				glBegin(GL_POLYGON);
				glTexCoord2f(0  ,1-  0);     glVertex2f(-1/1.0,-1/1.0);
				glTexCoord2f(0  ,1-  1);   glVertex2f(-1/1.0, 1/1.0);
				glTexCoord2f(1  ,1-  1);   glVertex2f(1/1.0 , 1/1.0);
				glTexCoord2f(1  ,1-  0);     glVertex2f(1/1.0 ,-1/1.0);
			glEnd();	
		glPopMatrix();
	}
	
	
	
	////////////////// Draw non-rotating Base platform
	//////////////////////////////////////////////////
	glBindTexture(GL_TEXTURE_2D, texName[0]);
	glBegin(GL_POLYGON);
		glTexCoord2f(0  ,1-  0);     glVertex2f(-1,-1);
		glTexCoord2f(0  ,1-  1);   glVertex2f(-1, 1);
		glTexCoord2f(1  ,1-  1);   glVertex2f(1 , 1);
		glTexCoord2f(1  ,1-  0);     glVertex2f(1 ,-1);
	glEnd();
	
	
	
	/////////////// Draw the moving platform
	////////////////////////////////////////
	glPushMatrix();
		glRotatef(-platformRotation, 0.0, 0.0, 1);
		glBindTexture(GL_TEXTURE_2D, texName[1]);
		glBegin(GL_POLYGON);
			glTexCoord2f(0,1-  0);   glVertex2f(-1,-1);
			glTexCoord2f(0,1-  1);   glVertex2f(-1,1);
			glTexCoord2f(1,1-  1);   glVertex2f(1,1);
			glTexCoord2f(1,1-  0);   glVertex2f(1,-1);
		glEnd();
	glPopMatrix();	


	
	/////////////// Draw disc:
	//////////////////////////	   		
	glPushMatrix();
		glTranslatef(discx, discy, 0.0);
		glRotatef(-discangle, 0.0, 0.0, 1);
		glBindTexture(GL_TEXTURE_2D, texName[3]);
		glBegin(GL_POLYGON);
			glTexCoord2f(0,1-  0);   glVertex2f(-1/16.0,-1/16.0);
			glTexCoord2f(0,1-  1);   glVertex2f(-1/16.0,+1/16.0);
			glTexCoord2f(1,1-  1);   glVertex2f(+1/16.0,+1/16.0);
			glTexCoord2f(1,1-  0);   glVertex2f(+1/16.0,-1/16.0);
		glEnd();
	glPopMatrix();
	



	//////////////// Draw ship:
	//////////////////////////
	glPushMatrix(); // All under the matrix of the ship's position.
		glTranslatef(shipx, shipy, 0.0);
		glRotatef(-shipangle, 0.0, 0.0, 1);
		glBindTexture(GL_TEXTURE_2D, texName[2]);
		glBegin(GL_POLYGON);
			glTexCoord2f(0,1-  0);   glVertex2f(-1/8.0,-1/8.0);
			glTexCoord2f(0,1-  1);   glVertex2f(-1/8.0,+1/8.0);
			glTexCoord2f(1,1-  1);   glVertex2f(+1/8.0,+1/8.0);
			glTexCoord2f(1,1-  0);   glVertex2f(+1/8.0,-1/8.0);
		glEnd();
		
		
		
		///////////////// DRAW EXHAUST
		///////////////////////////////
		//
		// Draw Small exhaust if 'i' is held down 
		if ((KeyDown['i'] || KeyDown['a']) && power==1) {
			glTranslatef(0, -0.16, 0.0);
			glBindTexture(GL_TEXTURE_2D, texName[5]);
			glBegin(GL_POLYGON);
				glTexCoord2f(0,1-  0);   glVertex2f(-1/24.0,-1/12.0);
				glTexCoord2f(0,1-  1);   glVertex2f(-1/24.0,+1/12.0);
				glTexCoord2f(1,1-  1);   glVertex2f(+1/24.0,+1/12.0);
				glTexCoord2f(1,1-  0);   glVertex2f(+1/24.0,-1/12.0);
			glEnd();
		}		
		//
		// Draw Big Exhaust if the thrust button is held and there are enough boosters:
		if (     (power==1 && booster>0 && (KeyDown['o'] || KeyDown['s']) )    ||
			     ((KeyDown['i'] || KeyDown['a']) && power==2)
			) {
			glTranslatef(0, -0.20, 0.0);
			glBindTexture(GL_TEXTURE_2D, texName[5]);
			glBegin(GL_POLYGON);
				glTexCoord2f(0,1-  0);   glVertex2f(-1/16.0,-1/8.0);
				glTexCoord2f(0,1-  1);   glVertex2f(-1/16.0,+1/8.0);
				glTexCoord2f(1,1-  1);   glVertex2f(+1/16.0,+1/8.0);
				glTexCoord2f(1,1-  0);   glVertex2f(+1/16.0,-1/8.0);
			glEnd();
		}


		// Draw Very Big Exhaust if the thrust button is held and there are enough boosters:
		if (     (booster>0 && (KeyDown['o'] || KeyDown['s']) && power==2) ) {
			glTranslatef(0, -0.20, 0.0);
			glBindTexture(GL_TEXTURE_2D, texName[5]);
			glBegin(GL_POLYGON);
				glTexCoord2f(0,1-  0);   glVertex2f(-1/12.0,-1/6.0);
				glTexCoord2f(0,1-  1);   glVertex2f(-1/12.0,+1/6.0);
				glTexCoord2f(1,1-  1);   glVertex2f(+1/12.0,+1/6.0);
				glTexCoord2f(1,1-  0);   glVertex2f(+1/12.0,-1/6.0);
			glEnd();
		}	


	glPopMatrix();
	

	////////////// Draw enemy:
	//////////////////////////
	glPushMatrix();
		glTranslatef(enemyx, enemyy, 0.0);
		glRotatef(-enemyangle, 0.0, 0.0, 1);
		glBindTexture(GL_TEXTURE_2D, texName[4]);
		glBegin(GL_POLYGON);
			glTexCoord2f(0,1-  0);   glVertex2f(-1/8.0,-1/8.0);
			glTexCoord2f(0,1-  1);   glVertex2f(-1/8.0,+1/8.0);
			glTexCoord2f(1,1-  1);   glVertex2f(+1/8.0,+1/8.0);
			glTexCoord2f(1,1-  0);   glVertex2f(+1/8.0,-1/8.0);
		glEnd();
	glPopMatrix();
	
	// help how do iset translucency to be half here (i.e. not around loading in texture map time)
	
	



	////////////// Draw the three pockets:
	//////////////////////////////////////
	//
	// First determine the texture to use for the three pockets:
	int	pocketTexture;
	//cout << (frame % ((int)(500.0*(changeGameSpeed+1)))) << endl;
	//if ((shipAim==true && frame%100 <50) || pow(discxo,2) + pow(discyo,2)>0.00003)
	if ((shipAim==true && frame%((int)(40000.0/changeGameSpeed)) < (int)(20000.0/changeGameSpeed)) || pow(discxo,2) + pow(discyo,2)>0.00003)
		{ if (inPocket==0) pocketTexture=7; else  pocketTexture=8;}
	else {pocketTexture=6;}
	//
	int pocketLeftTexture=pocketTexture;
	int pocketRightTexture=pocketTexture;
	int pocketTopTexture=pocketTexture;
	//
	//
	if (pocketLeftHitCount==2) { pocketLeftTexture=9; }
	glPushMatrix();
		glTranslatef(-0.9647, 0, 0.0);
		glBindTexture(GL_TEXTURE_2D, texName[pocketLeftTexture]);
		glBegin(GL_POLYGON);
			glTexCoord2f(0,1-  0);   glVertex2f(-1/8.0,-1/8.0);
			glTexCoord2f(0,1-  1);   glVertex2f(-1/8.0,+1/8.0);
			glTexCoord2f(1,1-  1);   glVertex2f(+1/8.0,+1/8.0);
			glTexCoord2f(1,1-  0);   glVertex2f(+1/8.0,-1/8.0);
		glEnd();
	glPopMatrix();
	//
	if (pocketRightHitCount==2) { pocketRightTexture=9; }	
	glPushMatrix();
		glTranslatef(0.9647, 0, 0.0);
		glBindTexture(GL_TEXTURE_2D, texName[pocketRightTexture]);
		glBegin(GL_POLYGON);
			glTexCoord2f(0,1-  0);   glVertex2f(-1/8.0,-1/8.0);
			glTexCoord2f(0,1-  1);   glVertex2f(-1/8.0,+1/8.0);
			glTexCoord2f(1,1-  1);   glVertex2f(+1/8.0,+1/8.0);
			glTexCoord2f(1,1-  0);   glVertex2f(+1/8.0,-1/8.0);
		glEnd();
	glPopMatrix();		
	//
	if (pocketTopHitCount==2) { pocketTopTexture=9; }	
	glPushMatrix();
		glTranslatef(0, 0.9647, 0.0);
		glBindTexture(GL_TEXTURE_2D, texName[pocketTopTexture]);
		glBegin(GL_POLYGON);
			glTexCoord2f(0,1-  0);   glVertex2f(-1/8.0,-1/8.0);
			glTexCoord2f(0,1-  1);   glVertex2f(-1/8.0,+1/8.0);
			glTexCoord2f(1,1-  1);   glVertex2f(+1/8.0,+1/8.0);
			glTexCoord2f(1,1-  0);   glVertex2f(+1/8.0,-1/8.0);
		glEnd();
	glPopMatrix();	




	glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);
 
 

	
	//if (frame>101) gamespeed = changeGameSpeed/fps;
	//else			gamespeed = changeGameSpeed/100;

	gamespeed = changeGameSpeed/fps;


 
 	////////////////////// Draw Text onto screen
 	/////////////////////////////////////////////
 	//
 	//glRasterPos2f(x, y);
	glColor3f(1.0,1.0,0.0);
	//
	char tlevel[50];
	char thit[50]; // help: 4 makes it go wrong
	//char tframe[50];
	char tbooster[50];
	char ttime[100];
	//
	//snprintf(tlevel,12," LEVEL: %f",5.7333685454537 ); // help Why?
	sprintf(tlevel," LEVEL: %0.2f",((int(enemyspeed*100))/100.0) );
	sprintf(thit," POTS: %i",hit);
	//sprintf(tframe,"%i",frame);
	sprintf(tbooster," BOOSTERS: %i",(int)booster);
	sprintf(ttime,"FPS: %0.2f ",fps);
	//
	// help if data is only declared 5, will memory overflow?
	renderBitmapString(-.9+camx, -.85+camy, GLUT_BITMAP_HELVETICA_18, tlevel);
	renderBitmapString(-.9+camx, -.95+camy, GLUT_BITMAP_HELVETICA_18, thit);
	//renderBitmapString(.5+camx, -.95+camy, GLUT_BITMAP_HELVETICA_18, tframe);
	glColor3f(0.0,1.0,0.0);
	renderBitmapString(.3+camx, -.85+camy, GLUT_BITMAP_HELVETICA_18, tbooster);
	renderBitmapString(.5+camx, -.95+camy, GLUT_BITMAP_HELVETICA_18, ttime);
	//
	// If ship is over edge in aiming mode:
	if (warning) {
	   	//system("PAUSE");
		char twarn[1000];	sprintf(twarn,"WARNING");
			glColor3f(1.0,0.0,0.0);
		 renderBitmapString(-.15+camx, .4+camy, GLUT_BITMAP_HELVETICA_18, twarn);
	}
	
	// Double power if reache level 5.5:
 	if(enemyspeed > 5.5 && enemyspeed < 5.56 && frame%20<10 && !gameover) {
		glColor3f(1.0,0.5,0.0);
		char tpow[1000];
		sprintf(tpow,"D O U B L E    P O W E R!"); 
		renderBitmapString(-0.37+camx, 0.26+camy, GLUT_BITMAP_HELVETICA_18, tpow);
		power=2.0;
	}
	
	
	
	
	
	
	
	
	
	

	/////////////// GAME OVER:
	//////////////////////////
	//
	if (gameover) {
		gameOverCountDown--; shipangle+=1*gamespeed;
		glColor3f(1.0,0.5,0.0);
		char go[50];char tpots[10];
		sprintf(go," LOST IN SPACE AT LEVEL: %0.2f",((int(enemyspeed*100))/100.0)  );
		sprintf(tpots," POTS: %i",hit );
		
		renderBitmapString(-0.55+camx, .35+camy, GLUT_BITMAP_HELVETICA_18, go);
		renderBitmapString(-0.1+camx, .2+camy, GLUT_BITMAP_HELVETICA_12, tpots);

		if (gameOverCountDown==0) {
			// Sleep(2000); // doesn't work on m$ compiler
			for (int wait=0 ; wait<1000000 ; wait++) {}
			resetVars();
		}  // help: how to exit??????????
	}

  }
	
	
    glutSwapBuffers();
}




void resetVars() {

	camx=0.0f,camy=0.0f,camz=0.0f;
	angle=0.0;
	ax=0.0f,ay=0.0f,az=-1.0f;
	deg = 3.141592653/180.0;
	
	shipx=0;
	shipy=-.5;
	
	discx=0,discxo=0;
	discy=0,discyo=0;
	discangle=0;
	
	enemyx=0,enemyxo=0;
	enemyy=0.5,enemyo=0;
	enemyangle=0;
	
	enemyspeed=1.0;
	
	enemySpeedupRate=0.0002;
	
	
	shipxthrust=0;
	shipythrust=0;
	thrust=25000; // lower = faster
	booster=200;
	power=1.0;
	
	hit=0; // Pocket pots
	frame=0; // frame number
	
	shipDiscDistance=0;
	
	shipAngleFromDisc=0;
	
	shipangle=0;
	
	platformRotation=false;
	platformRotationSpeed=0.01;
	prs=0;
	
	pocketTopHitCount=0;
	pocketLeftHitCount=0;
	pocketRightHitCount=0;
	
	planetx=-2.5;
	planety=-2.85;
	planetx2=0.5;
	planety2=2;
	planetx3=-4;
	planety3=1.5;
	
	rotd=0;
	roto=0;
	
	kdown=false;
	shipAim=false;
	pottable=false;
	takingShot=false;
	gameover=false;
	warning=false;
	intro=true;
	
	gameOverCountDown=500;
	gameoverStart=false;

	inPocket=0;
	
	shipAimRotDirection=1;	 
		 
	 
	 
	 	 intro=true; orientMe();
	 
}



        



void texturing(char* fileName,int imageWidth,int imageHeight ) { // help: why * and why not string??????????????????

	 //char image[imageHeight][imageWidth][4];
	 char* image = new char[imageHeight*imageWidth*4];

	 /* //for a two dimenensioal array
	 char** buffer;
	 buffer = (char**)malloc(sizeof(char*)*10);
	 for(int i = 0; i < 10; i++)
	 {
		 buffer[i] = (char*)malloc(sizeof(char)*10);
	 }
	 */

	 FILE *fp;  // help. why a pointer????????
	//if((fp = fopen(filename,"rb")) == NULL)
	//if((fp = fopen("pic.raw","rb")) == NULL)
	//{return 0;}
	
	fp = fopen(fileName,"rb"); // help: What is "rb" ?
	
	//unsigned char *image = new unsigned char[imageWidth*imageHeight*4];
	unsigned char r,g,b;
	
	
	
	for(int i=0; i<imageHeight; i++)
	{
		for(int j=0; j<imageWidth; j++)
		{
		 		// Creates blue/yello strobe pattern texture:
	 		/*image[i][j][0] = (GLubyte) 255-j; // Red
			image[i][j][1] = (GLubyte) 255-j; // Green
			image[i][j][2] = (GLubyte) 255-j*8; // Blue
			image[i][j][3] = (GLubyte) 255; // Alpha (transparency)
			*/
			
			//cout<<"hello world";
			int pos = i*imageWidth*4 + j*4;
			image[pos + 0] = getc(fp);
			image[pos + 1] = getc(fp);
			image[pos + 2] = getc(fp);
   			
   			if (image[pos +0]==0 && image[pos + 1]==0 && image[pos + 2]==0)
			   {image[pos + 3]=0;  }
   			else {image[pos + 3] = 255;    
   			
	   			
				if (textureNum==5) {image[pos + 3]=256-(i*8);  }
				if (textureNum==6) {image[pos + 3]= (pow(pow(i-32,2)+pow(j-32,2),0.5)*8)/2; }			   
				if (textureNum==7) {image[pos + 3]= (pow(pow(i-32,2)+pow(j-32,2),0.5)*16)/2; }			   
				if (textureNum==8) {image[pos + 3]= (pow(pow(i-32,2)+pow(j-32,2),0.5)*24)/2; }			   
				if (textureNum==9) {image[pos + 3]= (pow(pow(i-32,2)+pow(j-32,2),0.5)*64)/2; }			   
				   
			   } 
   			
   			  //if (textureNum==1) image[i][j][3] = 128;
   			
			// help: Any way to define whether transparency should include just one
			// level (the background color) or multiple levels (translucency)
			// ...for possible speedup.
			
			//image[i][j][3]= (GLubyte) 255;
			
			/*image[i*imageWidth*4 + j*4] = (GLubyte)getc(fp);
			image[i*imageWidth*4 + j*4+1] = (GLubyte)getc(fp);
			image[i*imageWidth*4 + j*4+2] = (GLubyte)getc(fp);
			image[i*imageWidth*4 + j*4+3] = (GLubyte) 255;*/
			
			
			//image[j]=255;
			
	//   		image[i*width*4+j*4+3] = getc(fp);
		}
	}
	fclose(fp);

	//glPixelStorei(GL_UNPACK_ALIGNMENT, 1); // Not needed 
	glGenTextures(1, &texName[textureNum]);
	glBindTexture(GL_TEXTURE_2D, texName[textureNum]);
	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT); // Not needed 
	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT); // Not needed 
	//glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST); // Not needed 
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, imageWidth,

	  imageHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, image);

	  textureNum++;
}

void keyboard(unsigned char key, int x, int y)
{
    KeyDown[key] = 1;
}

void keyboardUp(unsigned char key, int x, int y)
{
    KeyDown[key] = 0;
}




// Early bug testing

void detect()
{
glDisable(GL_TEXTURE_2D);
 	glColor3f(1.0,0,0.0);
 	glBegin(GL_POLYGON);
		glVertex2f(-.5,-.5);
		glVertex2f(0, .5);
		glVertex2f(.5 , -.5);
	glEnd();
	glEnable(GL_TEXTURE_2D);
}




void orientMe() {
	//gluPerspective(45,1,1,1000);
	//glMatrixMode(GL_MODELVIEW);

	//float ax = cos(angle);	float az = sin(angle); // how do i rotate on z axis?
	glLoadIdentity();

	//position		rotation			rotate z, x, y
	gluLookAt(camx,camy,camz,  ax+camx,ay+camy,az+camz,  0,1,0);
}






float getAngle(float x1,float y1,float x2,float y2){
	  float ang=atan((x1-x2)/(y1-y2)) / deg;
 	if (y1-y2>=0) ang+=180;
 	return ang;
}


float getDistance(float x1,float y1,float x2,float y2){
	  float dis = sqrt ((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2));
 	return dis;
}


float myfabs(float n) {
	  if (n<0) n=-n;
	  return n;	  
}


// http://www.lighthouse3d.com/opengl/glut/index.php?bmpfont
void renderBitmapString(float x, float y, void *font, char *string) {  // help: can char contain more than one character?
	char *c;
	glRasterPos2f(x, y);
	for (c=string; *c != '\0'; c++) {
		glutBitmapCharacter(font, *c);
	}
}


void renderSpacedBitmapString( float x, float y, int spacing, void *font, char *string) {
  char *c;
  int x1=x;
  for (c=string; *c != '\0'; c++) {
	glRasterPos2f(x1,y);
    	glutBitmapCharacter(font, *c);
	x1 = x1 + glutBitmapWidth(font,*c) + spacing;
  }
}

















void moveObjects() {
 

	 // Move trivial background planets when appropriate
	 if (enemyspeed>2.5 && enemyspeed<3.6) {
	 	planetx+=0.001*gamespeed;	 planety+=0.001*gamespeed;
	 }
	 
	 if (enemyspeed>5.4 && enemyspeed<6.5) {
	 	planetx2+=0.00025*1.2*gamespeed;	 planety2-=0.001*1.2*gamespeed;
	 }
	 
	 if (enemyspeed>8 && enemyspeed<9.2) {
	 	planetx3+=0.001*1.5*gamespeed;	 planety3-=0.00025*1.5*gamespeed;
	 }		 

	//////////////// Prelimanary stuff:
	///////////////////////////////////
 	// Used for various operation throughout:
	float shipEnemyDist = getDistance(shipx,shipy,enemyx,enemyy);




	////////////////////////// PLATFORM ROTATION MOVEMENT
	////////////////////////////////////////
	//		platformRotation+=platformRotationSpeed;
	platformRotation = (360*4)*pow(sin(prs*deg),2);
	rotd = platformRotation-roto;
	roto = platformRotation;

	if (shipAim==false)	prs += platformRotationSpeed*gamespeed;




	////////////////////////// SHIP MOVEMENT
	////////////////////////////////////////
	//glBlendFunc(1, 1);	
	// Old 'car style' thrust mechanism:
	// shipx+= sin(shipangle*(3.14159/180))*shipthrust;
	// shipy+= cos(shipangle*(3.14159/180))*shipthrust;
	//
	// Move ship with rotating platform:
	float	shipAngleFromCenter = (getAngle(0,0,shipx,shipy)+90) * deg;
	shipx+=sin(shipAngleFromCenter) * getDistance(0,0,shipx,shipy)*deg*rotd ;
	shipy+=cos(shipAngleFromCenter) * getDistance(0,0,shipx,shipy)*deg*rotd ;
	
	if(shipAim==false)	{ shipx+= shipxthrust*gamespeed;	shipy+= shipythrust*gamespeed;}

	int inv;

	// Repel ship from enemy:
	// Type 1 (default):
	shipxthrust+=(shipx-enemyx)/pow(shipEnemyDist,3)/1E6 *gamespeed;
	shipythrust+=(shipy-enemyy)/pow(shipEnemyDist,3)/1E6 *gamespeed;
	// Type 2:		
	//	shipxthrust+=(shipx-enemyx)/pow(shipEnemyDist,2)/1E5;
	//	shipythrust+=(shipy-enemyy)/pow(shipEnemyDist,2)/1E5;
	
	// Ship Friction:
	if(shipAim==false)	{ shipxthrust/=pow(1.002,(double)gamespeed);     }	
	
	//shipythrust/=pow(1.002,gamespeed);}


	//	shipangle+=rotd;   // << Rotate ship with platform if desired









 	// Track camera onto ship for both axis:
	camx=shipx; orientMe();
	camy=shipy; orientMe();




	float discSpeed = pow(discxo,2) + pow(discyo,2); // used for some math below



	//////////////// Move enemy:
	////////////////////////////
	//
	// Attract enemy to ship:
		if (!shipAim) {
		// enemyangle=shipEnemyDist*200;
		enemyangle+=enemyspeed*gamespeed;
		
		enemyx+=(shipx-enemyx)/shipEnemyDist*enemyspeed/1000.0*gamespeed;
		enemyy+=(shipy-enemyy)/shipEnemyDist*enemyspeed/1000.0*gamespeed;
	
		if (!gameover)
		enemyspeed+=enemySpeedupRate*gamespeed;  // Enemy gets faster!!!

	// Repel enemy from disc:
		// Original:
		//enemyx+=(enemyx-discx)/pow(getDistance(discx,discy,enemyx,enemyy),3)/2E3;
		//enemyy+=(enemyy-discy)/pow(getDistance(discx,discy,enemyx,enemyy),3)/2E3;
		
		// Game type 1
		enemyx+=(enemyx-discx)/pow(getDistance(discx,discy,enemyx,enemyy),3)*(enemyspeed/2)/2E3*gamespeed;
		enemyy+=(enemyy-discy)/pow(getDistance(discx,discy,enemyx,enemyy),3)*(enemyspeed/2)/2E3*gamespeed;
		
		// Game type 2
		//enemyx+=(enemyx-discx)/pow(getDistance(discx,discy,enemyx,enemyy),2)/(enemyspeed)/2E3;
		//enemyy+=(enemyy-discy)/pow(getDistance(discx,discy,enemyx,enemyy),2)/(enemyspeed)/2E3;

	}


	//////////////////////// Move disc:
	///////////////////////////////////
	//
	// Rotate disc:
	if (shipAim==false) { discangle+=4*gamespeed; }
	if (shipAim==true) { discangle+=16*gamespeed; }	
	if (takingShot) discangle+=64*gamespeed;
	//
	// Move it:
	if (shipAim==false && inPocket==0) { 
		discx+=discxo*gamespeed;
		discy+=discyo*gamespeed;
	}






	/////////////////////////////// Special aiming routine. Move Ship /and/ Disc:
	/////////////////////////////////////////////////////////////////////////////
	if(shipAim==true && inPocket==0) {
		 	
		 shipAngleFromDisc = (getAngle(discx,discy,shipx,shipy)+90) * deg;
		 
		 //# ship disc rotate aim
		 // Use shipDiscDistance instead of getDistance() for less chaos ;-)
		 discx+=sin(shipAngleFromDisc) * getDistance(discx,discy,shipx,shipy)*deg*0.5*shipAimRotDirection*gamespeed;
		 discy+=cos(shipAngleFromDisc) * getDistance(discx,discy,shipx,shipy)*deg*0.5*shipAimRotDirection*gamespeed;
		 
		 shipx+=sin(shipAngleFromDisc+(180*deg)) * getDistance(discx,discy,shipx,shipy)*deg*0.5*shipAimRotDirection*gamespeed;
		 shipy+=cos(shipAngleFromDisc+(180*deg)) * getDistance(discx,discy,shipx,shipy)*deg*0.5*shipAimRotDirection*gamespeed;
		 
		 shipangle=	 (shipAngleFromDisc/deg + 90);
	 }
	 
	 if (inPocket>0)  inPocket--;
	 
	 



}










void collision() {
	
	/////////////////////////////////////////////////////////////////
	//////////////////////////////// Ship/Border Collision detection:
 	if ( shipy>-0.344 && shipy<0.344 && (shipx<-1 || shipx>1))	 gameover=true;	
	if ( shipx>-0.344 && shipx<0.344 && (shipy>1))	{ gameover=true;   }
 	if ( shipx>-0.5156 && shipx<0.5156 && shipy<-0.8125)	 gameover=true;
	// Diagonals:
	if (shipx<-0.344 && shipy>0.344   && shipx+(1-shipy) < -0.3444  )	 gameover=true;
	if (shipx>0.344 && shipy>0.344   && (1-shipx)+(1-shipy) < 0.3444*2  )	 gameover=true;
	if (shipx<-0.5156 && shipy<-0.344   && shipx+shipy < -((1-.5156)*2+0.344)  )	 gameover=true;
	if (shipx>0.5156 && shipy<-0.344   && (1-shipx)+shipy < -0.344  )	 gameover=true;

	warning=false;
	if (gameover && shipAim) {gameover=false; warning=true;}
	// For waiting times, it's always /gamespeed, otherwise, for movements, it's * gamespeed
	if (gameover && !gameoverStart) { gameOverCountDown=1000.0/gamespeed; gameoverStart=true;}


	////////////////////// Disc/Border Collision detection:
	///////////////////////////////////////////////////////
	float extra=0.03;
	float discF=1.4;
 	if ( discy>-0.344 && discy<0.344 && (discx<-1+extra))	{  discxo/=discF;discyo/=discF;discxo=myfabs(discxo);	}
 	if ( discy>-0.344 && discy<0.344 && (discx> 1-extra))	{  discxo/=discF;discyo/=discF;discxo=-myfabs(discxo);	}
 	if ( discx>-0.344 && discx<0.344 && (discy>1-extra)){ discxo/=discF;discyo/=discF;	 discyo=-myfabs(discyo);}
 	if ( discx>-0.5156 && discx<0.5156 && discy<-0.8125+extra) { discxo/=discF;discyo/=discF;	 discyo=myfabs(discyo);}
	// quoted out old Diagonals:
	//if (discx<-0.344 && discy>0.344   && discx+(1-discy-extra) < -0.3444  ){ discxo/=discF;discyo/=discF;	                    discxo=myfabs(discxo); discyo=-myfabs(discyo);}
	//if (discx>0.344 && discy>0.344   && (1-discx-extra)+(1-discy-extra) < 0.3444*2  ){ discxo/=discF;discyo/=discF;	 discxo=-myfabs(discxo); discyo=-myfabs(discyo);}
	//if (discx<-0.5156 && discy<-0.344   && discx+discy < -((1-.5156)*2+0.344)-extra  ){ discxo/=discF;discyo/=discF;	 discxo=myfabs(discxo); discyo=myfabs(discyo);}
	//if (discx>0.5156 && discy<-0.344   && (1-discx)+discy < -0.344+extra  ){ discxo/=discF;discyo/=discF;	 discxo=-myfabs(discxo); discyo=myfabs(discyo);}
	
	// Proper bouncing of diagonals
	//if (timeSinceLastReboundA>10 && discx<-0.344 && discy>0.344   && discx+(1-discy-extra) < -0.3444  )				{timeSinceLastReboundA=0;  discxo/=discF;discyo/=discF;	double tmp=discxo;  discxo=discyo; discyo=tmp;}
	//if (timeSinceLastReboundB>10 && discx>0.344 && discy>0.344   && (1-discx-extra)+(1-discy-extra) < 0.3444*2  )	{timeSinceLastReboundB=0;  discxo/=discF;discyo/=discF;	double tmp=discxo;  discxo=-discyo; discyo=-tmp;}
	//if (timeSinceLastReboundC>10 && discx<-0.5156 && discy<-0.344   && discx+discy < -((1-.5156)*2+0.344)-extra  )	{timeSinceLastReboundC=0;  discxo/=discF;discyo/=discF; double tmp=discxo;	discxo=-discyo; discyo=-tmp;}
	//if (timeSinceLastReboundD>10 && discx>0.5156 && discy<-0.344   && (1-discx)+discy < -0.344+extra  )				{timeSinceLastReboundD=0;  discxo/=discF;discyo/=discF; double tmp=discxo;	discxo=discyo; discyo=tmp;}

	// Pseudo-proper way of bouncing of diagonals
	if (timeSinceLastReboundA>1 && discx<-0.344 && discy>0.344   && discx+(1-discy-extra) < -0.3444  )				{timeSinceLastReboundA=0;  discxo/=discF;discyo/=discF;	double tmp=discxo;  discxo=myfabs(discyo); discyo=-myfabs(tmp);}
	if (timeSinceLastReboundB>1 && discx>0.344 && discy>0.344   && (1-discx-extra)+(1-discy-extra) < 0.3444*2  )	{timeSinceLastReboundB=0;  discxo/=discF;discyo/=discF;	double tmp=discxo;  discxo=-myfabs(discyo); discyo=-myfabs(tmp);}
	if (timeSinceLastReboundC>1 && discx<-0.5156 && discy<-0.344   && discx+discy < -((1-.5156)*2+0.344)-extra  )	{timeSinceLastReboundC=0;  discxo/=discF;discyo/=discF; double tmp=discxo;	discxo=myfabs(discyo); discyo=myfabs(tmp);}
	if (timeSinceLastReboundD>1 && discx>0.5156 && discy<-0.344   && (1-discx)+discy < -0.344+extra  )				{timeSinceLastReboundD=0;  discxo/=discF;discyo/=discF; double tmp=discxo;	discxo=-myfabs(discyo); discyo=myfabs(tmp);}

	
	timeSinceLastReboundA++;
	timeSinceLastReboundB++;
  	timeSinceLastReboundC++; 
 	timeSinceLastReboundD++;
 	
	////////////////////// Disc/Pocket Collision detection:
	///////////////////////////////////////////////////////
	if (pow(discxo,2) + pow(discyo,2)>0.00003)   takingShot=true;	   else takingShot=false;
	if(pocketLeftHitCount<2 && pottable && takingShot &&  pow(-0.9647  -discx,2) + pow(0  -discy,2) < pow( 1/24.0,2)  ) {pocketLeftHitCount++; pocketRightHitCount=0; pocketTopHitCount=0; inPocket=100.0/gamespeed; booster+=50; hit++; pottable=false; discx=-0.9647; discy=0; }
	if(pocketRightHitCount<2 && pottable && takingShot &&  pow(0.9647  -discx,2) + pow(0  -discy,2) < pow( 1/24.0,2)  ) {pocketRightHitCount++; pocketLeftHitCount=0; pocketTopHitCount=0; inPocket=100.0/gamespeed; booster+=50;  hit++; pottable=false; discx=0.9647; discy=0;  }
	if(pocketTopHitCount<2 && pottable && takingShot &&  pow(0  -discx,2) + pow(0.9647  -discy,2) < pow( 1/24.0,2)  ) {pocketTopHitCount++;   pocketLeftHitCount=0 ; pocketRightHitCount=0; inPocket=100.0/gamespeed; booster+=50;  hit++; pottable=false; discx=0; discy=0.9647;  }
	
	

	////////////////////////////////// Pocket/ship Collision Detection:
	///////////////////////////////////////////////////////////////////
	// Force field around pockets partly to prevent cheating and also to add a bouncing dynamic to the border.
	// Higher 100000 if I end up having less than force*8 for ship thrust
	if(pow(-0.9647  -shipx,2) + pow(0  -shipy,2) < pow( 1/4.0,2)  ) { // was 1/4
		shipxthrust-=	(-0.9647-shipx)/pow(getDistance(shipx,shipy,-0.9647,0),3)/200000*gamespeed; // was 200000
		shipythrust-=	(0-shipy)/pow(getDistance(shipx,shipy,-0.9647,0),3)/200000*gamespeed;
		}
	if(pow(0.9647  -shipx,2) + pow(0  -shipy,2) < pow( 1/4.0,2)  ) {
		shipxthrust-=	(0.9647-shipx)/pow(getDistance(shipx,shipy,0.9647,0),3)/200000*gamespeed;
		shipythrust-=	(0-shipy)/pow(getDistance(shipx,shipy,0.9647,0),3)/200000*gamespeed;
		}	
	if(pow(0  -shipx,2) + pow(0.9647  -shipy,2) < pow( 1/4.0,2)  ) {
		shipxthrust-=	(0-shipx)/pow(getDistance(shipx,shipy,0,0.9647),3)/200000*gamespeed;
		shipythrust-=	(0.9647-shipy)/pow(getDistance(shipx,shipy,0,0.9647),3)/200000*gamespeed;
		}




	/////////////// Disc/Ship 'Collision' (pythagoras):
	///////////////////////////////////////////////////
	if(  pow(shipx-discx,2) + pow(shipy-discy,2) < pow( 1/16.0 + 1/8.0,2)/4  )
		{
	 	 pottable=true;
	 	 shipAim=true; shipDiscDistance=getDistance(discx,discy,shipx,shipy)*deg*1;
	 	 shipxthrust=0;
	 	 shipythrust=0;
 	}


}







void keys() {
	 
	// Control ship with keys:
	//////////////////////////
	//////////////////////////
	//////////////////////////
	//
	   if (KeyDown['i'] || KeyDown['a'] ) {
  				 //shipthrust+=0.000005;
		 shipxthrust+=sin(shipangle*deg)/thrust*1*power*gamespeed;
		 shipythrust+=cos(shipangle*deg)/thrust*1*power*gamespeed;
				 }
   	   if (booster>0 && !shipAim && (KeyDown['o'] || KeyDown['s']) ) {				 
		 shipxthrust+=sin(shipangle*deg)/thrust*3*power*gamespeed;
		 shipythrust+=cos(shipangle*deg)/thrust*3*power*gamespeed;
		 booster-=gamespeed;
		 }


 	   if (KeyDown['j']) {shipangle-=1*gamespeed;}
 	   if (KeyDown['l']) {shipangle+=1*gamespeed;}
 	   

   	   if (KeyDown['k'] && kdown==false) {
	   	  				kdown=true;
	   	  		if (shipAim==false)	{	shipangle+=180;}
	   	  		else shipAimRotDirection=-shipAimRotDirection;
	   	  		
  				if (KeyDown['k']==false) kdown=false;	 
		   		}
   		
   		if (!KeyDown['k']) kdown=false;
					 
					 
					 
   	   if (shipAim && KeyDown[' ']) {

	   	  		shipAim=false;
	   	  		discxo=sin(shipangle*deg)*0.006;
	   	  		discyo=cos(shipangle*deg)*0.006;
	   	  		
				shipxthrust=-sin(shipangle*deg)*0.001;
	   	  		shipythrust=-cos(shipangle*deg)*0.001;
				}
					 
	   	  				
						

 	   
     /*if ( KeyDown['r'] )  { y+=.005; orientMe(); } // where would be a good place to have this?
     if ( KeyDown['g'] )  { y-=.005; orientMe(); }// where would be a good place to have this?
     if ( KeyDown['o'] )  { x-=.005; orientMe(); }// where would be a good place to have this?
     if ( KeyDown['p'] )  { x+=.005; orientMe(); }// where would be a good place to have this?
	if ( KeyDown['['] )  { angle-=.01; orientMe(); }// where would be a good place to have this?
	if ( KeyDown[']'] )  { angle+=.01; orientMe(); }// where would be a good place to hthis?

	if ( KeyDown['q'] )  { z-=.01; orientMe(); }//  how do i increase depth size?
	if ( KeyDown['w'] )  { z+=.01; orientMe(); }//
	*/
} 


//void gameOverRoutine() {
//
//}





static void idle()
{

 		if (KeyDown[' ']) {intro=false;}
 		
	   if (intro!=true) {
	 	   moveObjects();
		   collision();
		}

	   glutDisplayFunc(display); // help: have this here or in main() ?
 
		if (gameover==false)
  		keys();   

 	   //Sleep(1000); // 70 frames per second
 	   // http://www.newton.dep.anl.gov/askasci/comp99/CS042.htm
 	   
    glutPostRedisplay();
}



int main(int argc, char *argv[])
{
 	
 	//cout<<"woof";
    glutInit(&argc, argv);

//    glutInitWindowSize(512,512);
    
    glutInitWindowSize(512,512);
    
    glutInitWindowPosition(10,10);
    //glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	
    glutCreateWindow("AstraGrid");
    
    texturing("back.raw",512,512);
	texturing("backspin.raw",512,512);
	texturing("ship.raw",64,64);
	texturing("disc.raw",32,32);
	texturing("enemy.raw",64,64);
	texturing("exhaust.raw",32,32);
	texturing("pocketff.raw",64,64);	// Pocket force field
	texturing("pocketff.raw",64,64);	// Pocket force field
	texturing("pocketff.raw",64,64);	// Pocket force field
	texturing("pocketff.raw",64,64);	// Pocket force field
	texturing("stars.raw",512,512);	// 
	texturing("planet1.raw",128,128);
	texturing("planet2.raw",256,256);
	texturing("front.raw",512,512);	
			
	
	//texturing("backf.raw",512,512);
	
	// keyboard code taken from http://www.nullterminator.net/glut.html	
    memset( KeyDown, 0, sizeof( KeyDown ) );
    glutKeyboardFunc( keyboard );
    // help: shouldn't it be if glutKeyboardFunc() { keyboard; }
    glutKeyboardUpFunc( keyboardUp );

    glutIdleFunc(idle);
    glutMainLoop();

    return EXIT_SUCCESS;
}

// help: how do i slow down ap? to 50fps?






/*
help:
* position an object independant of camera
* convert to AVI!!!
* mouse moving and not stopping at end of screen
* Why in OpenGL.pdf is GLubyte used for "Creating a Texture", but char is used 
* for loading an image??????????
* Where can i find the checquered board prog?
*/
